Index: tmp/org.txm.core/res/org/txm/xml/xsl/tei/xhtml2/oddprocessing.xsl
===================================================================
--- tmp/org.txm.core/res/org/txm/xml/xsl/tei/xhtml2/oddprocessing.xsl	(revision 2396)
+++ tmp/org.txm.core/res/org/txm/xml/xsl/tei/xhtml2/oddprocessing.xsl	(revision 2397)
@@ -289,656 +374,755 @@
 	  </xsl:otherwise>
 	</xsl:choose>
       </xsl:attribute>
-      <xsl:choose>
-        <xsl:when test="$simple='true'">
-          <xsl:apply-templates mode="verbatim">
-            <xsl:with-param name="highlight">
-              <xsl:value-of select="$highlight"/>
-            </xsl:with-param>
-          </xsl:apply-templates>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:call-template name="egXMLStartHook"/>
-          <xsl:apply-templates mode="verbatim">
-            <xsl:with-param name="highlight">
-              <xsl:value-of select="$highlight"/>
-            </xsl:with-param>
-          </xsl:apply-templates>
-          <xsl:call-template name="egXMLEndHook"/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </div>
-  </xsl:template>
-  <doc xmlns="http://www.oxygenxml.com/ns/doc/xsl">
-    <desc>[html] <param name="grammar">grammar</param>
-         <param name="content">content</param>
-         <param name="element">element</param>
-      </desc>
-  </doc>
-  <xsl:template name="bitOut">
-    <xsl:param name="grammar"/>
-    <xsl:param name="content"/>
-    <xsl:param name="element">pre</xsl:param>
-    <xsl:choose>
-      <xsl:when test="$displayMode='both'">
-        <div class="displayRelax">
-          <button class="displayRelaxButton">
-            <span class="RNG_Compact">
-              <xsl:call-template name="i18n">
-                <xsl:with-param name="word">Compact to XML format</xsl:with-param>
-              </xsl:call-template>
-            </span>
-            <span class="RNG_XML">
-              <xsl:call-template name="i18n">
-                <xsl:with-param name="word">XML format to compact</xsl:with-param>
-              </xsl:call-template>
-            </span>
-          </button>
-          <pre class="RNG_XML">
-            <xsl:apply-templates mode="verbatim" select="$content/*/*"/>
-          </pre>
-          <pre class="RNG_Compact">
-            <xsl:call-template name="make-body-from-r-t-f">
-              <xsl:with-param name="schema">
-                <xsl:for-each select="$content/*">
-                  <xsl:call-template name="make-compact-schema"/>
-                </xsl:for-each>
-              </xsl:with-param>
-            </xsl:call-template>
-          </pre>
-        </div>
-      </xsl:when>
-      <xsl:when test="$displayMode='rng'">
-        <xsl:element name="{$element}">
-          <xsl:attribute name="class">eg</xsl:attribute>
-          <xsl:apply-templates mode="verbatim" select="$content/*/*"/>
-        </xsl:element>
-      </xsl:when>
-      <xsl:when test="$displayMode='rnc'">
-        <xsl:element name="{$element}">
-          <xsl:attribute name="class">eg</xsl:attribute>
-          <xsl:call-template name="make-body-from-r-t-f">
-            <xsl:with-param name="schema">
-              <xsl:for-each select="$content/*">
-                <xsl:call-template name="make-compact-schema"/>
-              </xsl:for-each>
-            </xsl:with-param>
-          </xsl:call-template>
-        </xsl:element>
-      </xsl:when>
-      <xsl:otherwise>
-        <xsl:element name="{$element}">
-          <xsl:attribute name="class">eg</xsl:attribute>
-          <xsl:for-each select="$content/*">
-            <xsl:apply-templates mode="literal"/>
-          </xsl:for-each>
-        </xsl:element>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <xsl:template name="showSpace">
-    <xsl:text> </xsl:text>
-  </xsl:template>
-  <xsl:template name="showSpaceBetweenItems">
-    <xsl:text> </xsl:text>
-  </xsl:template>
-  <xsl:template match="tei:schemaSpec">
-    <xsl:choose>
-      <xsl:when test="tei:specGrpRef">
-        <xsl:variable name="SPECS">
-          <tei:schemaSpec>
-            <xsl:copy-of select="@*"/>
-            <xsl:apply-templates mode="expandSpecs"/>
-          </tei:schemaSpec>
-        </xsl:variable>
-        <xsl:for-each select="$SPECS/tei:schemaSpec">
-          <xsl:call-template name="schemaSpecWeave"/>
-        </xsl:for-each>
-      </xsl:when>
-      <xsl:otherwise>
-        <xsl:call-template name="schemaSpecWeave"/>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <xsl:template name="schemaSpecWeave">
-    <xsl:if test="$verbose='true'">
-      <xsl:message>Processing schemaSpec <xsl:value-of select="@ident"/>, summaryDoc=<xsl:value-of select="$summaryDoc"/>
-         </xsl:message>
-    </xsl:if>
-    <xsl:choose>
-      <xsl:when test="$summaryDoc='true'">
-        <h2>Schema <xsl:value-of select="@ident"/>: changed components</h2>
-        <xsl:for-each select="tei:classSpec[@mode or @rend='change']        | tei:macroSpec[(@mode or @rend='change')]        | tei:elementSpec[(@mode or @rend='change')]">
-          <xsl:sort select="@ident"/>
-          <xsl:apply-templates mode="weave" select="."/>
-        </xsl:for-each>
-        <h2>Schema <xsl:value-of select="@ident"/>:  unchanged  components</h2>
-        <table>
-          <xsl:for-each select="tei:classSpec[not(@mode or @rend)]          | tei:macroSpec[not(@mode or  @rend)]          | tei:elementSpec[not(@mode or @rend)]">
-            <xsl:sort select="@ident"/>
-            <tr>
-              <td id="{@ident}"><a href="http://www.tei-c.org/release/doc/tei-p5-doc/{$documentationLanguage}/html/ref-{@ident}.html"><xsl:value-of select="@ident"/></a>:
-		     <xsl:call-template name="makeDescription"/></td>
-            </tr>
-          </xsl:for-each>
-        </table>
-      </xsl:when>
-      <xsl:otherwise>
-        <h2>Schema <xsl:value-of select="@ident"/>: Elements</h2>
-        <xsl:apply-templates mode="weave" select="tei:elementSpec">
-          <xsl:sort select="@ident"/>
-        </xsl:apply-templates>
-        <xsl:if test="tei:classSpec[@type='model']">
-          <h2>Schema <xsl:value-of select="@ident"/>: Model classes</h2>
-          <xsl:apply-templates mode="weave" select="tei:classSpec[@type='model']">
-            <xsl:sort select="@ident"/>
-          </xsl:apply-templates>
-        </xsl:if>
-        <xsl:if test="tei:classSpec[@type='atts']">
-          <h2>Schema <xsl:value-of select="@ident"/>: Attribute classes</h2>
-          <xsl:apply-templates mode="weave" select="tei:classSpec[@type='atts']">
-            <xsl:sort select="@ident"/>
-          </xsl:apply-templates>
-        </xsl:if>
-        <xsl:if test="tei:macroSpec">
-          <h2>Schema <xsl:value-of select="@ident"/>: Macros</h2>
-          <xsl:apply-templates mode="weave" select="tei:macroSpec">
-            <xsl:sort select="@ident"/>
-          </xsl:apply-templates>
-        </xsl:if>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <doc xmlns="http://www.oxygenxml.com/ns/doc/xsl">
-    <desc>[odds] make a link<param name="name">name</param>
-         <param name="id">id</param>
-      </desc>
-  </doc>
-  <xsl:template name="makeSectionHead">
-    <xsl:param name="name"/>
-    <xsl:param name="id"/>
-    <h3>
-      <xsl:attribute name="class">
+			<xsl:choose>
+				<xsl:when test="$simple='true'">
+					<xsl:apply-templates mode="verbatim">
+						<xsl:with-param name="highlight">
+							<xsl:value-of select="$highlight" />
+						</xsl:with-param>
+					</xsl:apply-templates>
+				</xsl:when>
+				<xsl:otherwise>
+					<xsl:call-template name="egXMLStartHook" />
+					<xsl:apply-templates mode="verbatim">
+						<xsl:with-param name="highlight">
+							<xsl:value-of select="$highlight" />
+						</xsl:with-param>
+					</xsl:apply-templates>
+					<xsl:call-template name="egXMLEndHook" />
+				</xsl:otherwise>
+			</xsl:choose>
+		</div>
+	</xsl:template>
+	<doc xmlns="http://www.oxygenxml.com/ns/doc/xsl">
+		<desc>
+			[html]
+			<param name="grammar">grammar</param>
+			<param name="content">content</param>
+			<param name="element">element</param>
+		</desc>
+	</doc>
+	<xsl:template name="bitOut">
+		<xsl:param name="grammar" />
+		<xsl:param name="content" />
+		<xsl:param name="element">
+			pre
+		</xsl:param>
+		<xsl:choose>
+			<xsl:when test="$displayMode='both'">
+				<div class="displayRelax">
+					<button class="displayRelaxButton">
+						<span class="RNG_Compact">
+							<xsl:call-template name="i18n">
+								<xsl:with-param name="word">
+									Compact to XML format
+								</xsl:with-param>
+							</xsl:call-template>
+						</span>
+						<span class="RNG_XML">
+							<xsl:call-template name="i18n">
+								<xsl:with-param name="word">
+									XML format to compact
+								</xsl:with-param>
+							</xsl:call-template>
+						</span>
+					</button>
+					<pre class="RNG_XML">
+						<xsl:apply-templates mode="verbatim"
+							select="$content/*/*" />
+					</pre>
+					<pre class="RNG_Compact">
+						<xsl:call-template name="make-body-from-r-t-f">
+							<xsl:with-param name="schema">
+								<xsl:for-each select="$content/*">
+									<xsl:call-template name="make-compact-schema" />
+								</xsl:for-each>
+							</xsl:with-param>
+						</xsl:call-template>
+					</pre>
+				</div>
+			</xsl:when>
+			<xsl:when test="$displayMode='rng'">
+				<xsl:element name="{$element}">
+					<xsl:attribute name="class">eg</xsl:attribute>
+					<xsl:apply-templates mode="verbatim"
+						select="$content/*/*" />
+				</xsl:element>
+			</xsl:when>
+			<xsl:when test="$displayMode='rnc'">
+				<xsl:element name="{$element}">
+					<xsl:attribute name="class">eg</xsl:attribute>
+					<xsl:call-template name="make-body-from-r-t-f">
+						<xsl:with-param name="schema">
+							<xsl:for-each select="$content/*">
+								<xsl:call-template name="make-compact-schema" />
+							</xsl:for-each>
+						</xsl:with-param>
+					</xsl:call-template>
+				</xsl:element>
+			</xsl:when>
+			<xsl:otherwise>
+				<xsl:element name="{$element}">
+					<xsl:attribute name="class">eg</xsl:attribute>
+					<xsl:for-each select="$content/*">
+						<xsl:apply-templates mode="literal" />
+					</xsl:for-each>
+				</xsl:element>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<xsl:template name="showSpace">
+		<xsl:text> </xsl:text>
+	</xsl:template>
+	<xsl:template name="showSpaceBetweenItems">
+		<xsl:text> </xsl:text>
+	</xsl:template>
+	<xsl:template match="tei:schemaSpec">
+		<xsl:choose>
+			<xsl:when test="tei:specGrpRef">
+				<xsl:variable name="SPECS">
+					<tei:schemaSpec>
+						<xsl:copy-of select="@*" />
+						<xsl:apply-templates mode="expandSpecs" />
+					</tei:schemaSpec>
+				</xsl:variable>
+				<xsl:for-each select="$SPECS/tei:schemaSpec">
+					<xsl:call-template name="schemaSpecWeave" />
+				</xsl:for-each>
+			</xsl:when>
+			<xsl:otherwise>
+				<xsl:call-template name="schemaSpecWeave" />
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<xsl:template name="schemaSpecWeave">
+		<xsl:if test="$verbose='true'">
+			<xsl:message>
+				Processing schemaSpec
+				<xsl:value-of select="@ident" />
+				, summaryDoc=
+				<xsl:value-of select="$summaryDoc" />
+			</xsl:message>
+		</xsl:if>
+		<xsl:choose>
+			<xsl:when test="$summaryDoc='true'">
+				<h2>
+					Schema
+					<xsl:value-of select="@ident" />
+					: changed components
+				</h2>
+				<xsl:for-each
+					select="tei:classSpec[@mode or @rend='change']        | tei:macroSpec[(@mode or @rend='change')]        | tei:elementSpec[(@mode or @rend='change')]">
+					<xsl:sort select="@ident" />
+					<xsl:apply-templates mode="weave" select="." />
+				</xsl:for-each>
+				<h2>
+					Schema
+					<xsl:value-of select="@ident" />
+					: unchanged components
+				</h2>
+				<table>
+					<xsl:for-each
+						select="tei:classSpec[not(@mode or @rend)]          | tei:macroSpec[not(@mode or  @rend)]          | tei:elementSpec[not(@mode or @rend)]">
+						<xsl:sort select="@ident" />
+						<tr>
+							<td id="{@ident}">
+								<a
+									href="http://www.tei-c.org/release/doc/tei-p5-doc/{$documentationLanguage}/html/ref-{@ident}.html">
+									<xsl:value-of select="@ident" />
+								</a>
+								:
+								<xsl:call-template name="makeDescription" />
+							</td>
+						</tr>
+					</xsl:for-each>
+				</table>
+			</xsl:when>
+			<xsl:otherwise>
+				<h2>
+					Schema
+					<xsl:value-of select="@ident" />
+					: Elements
+				</h2>
+				<xsl:apply-templates mode="weave"
+					select="tei:elementSpec">
+					<xsl:sort select="@ident" />
+				</xsl:apply-templates>
+				<xsl:if test="tei:classSpec[@type='model']">
+					<h2>
+						Schema
+						<xsl:value-of select="@ident" />
+						: Model classes
+					</h2>
+					<xsl:apply-templates mode="weave"
+						select="tei:classSpec[@type='model']">
+						<xsl:sort select="@ident" />
+					</xsl:apply-templates>
+				</xsl:if>
+				<xsl:if test="tei:classSpec[@type='atts']">
+					<h2>
+						Schema
+						<xsl:value-of select="@ident" />
+						: Attribute classes
+					</h2>
+					<xsl:apply-templates mode="weave"
+						select="tei:classSpec[@type='atts']">
+						<xsl:sort select="@ident" />
+					</xsl:apply-templates>
+				</xsl:if>
+				<xsl:if test="tei:macroSpec">
+					<h2>
+						Schema
+						<xsl:value-of select="@ident" />
+						: Macros
+					</h2>
+					<xsl:apply-templates mode="weave"
+						select="tei:macroSpec">
+						<xsl:sort select="@ident" />
+					</xsl:apply-templates>
+				</xsl:if>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<doc xmlns="http://www.oxygenxml.com/ns/doc/xsl">
+		<desc>
+			[odds] make a link
+			<param name="name">name</param>
+			<param name="id">id</param>
+		</desc>
+	</doc>
+	<xsl:template name="makeSectionHead">
+		<xsl:param name="name" />
+		<xsl:param name="id" />
+		<h3>
+			<xsl:attribute name="class">
       <xsl:text>oddSpec</xsl:text>
       <xsl:if test="@status">
 	<xsl:text> status_</xsl:text>
-	<xsl:value-of select="@status"/>
+	<xsl:value-of select="@status" />
       </xsl:if>
       </xsl:attribute>
-      <xsl:call-template name="makeAnchor">
-        <xsl:with-param name="name">
-          <xsl:value-of select="$id"/>
-        </xsl:with-param>
-      </xsl:call-template>
-      <xsl:value-of select="$name"/>
-      <xsl:if test="@ns">
-	[<xsl:value-of select="@ns"/>]
-      </xsl:if>
-    </h3>
-  </xsl:template>
-  <xsl:template name="specHook">
-    <xsl:param name="name"/>
-  </xsl:template>
-  <xsl:template match="tei:ident">
-    <xsl:choose>
-      <xsl:when test="@type='class' and key('CLASSES',.)">
-        <xsl:call-template name="linkTogether">
-          <xsl:with-param name="name">
-            <xsl:value-of select="."/>
-          </xsl:with-param>
-          <xsl:with-param name="reftext">
-            <xsl:value-of select="."/>
-          </xsl:with-param>
-        </xsl:call-template>
-      </xsl:when>
-      <xsl:when test="@type">
-        <span class="ident-{@type}">
-          <xsl:apply-templates/>
-        </span>
-      </xsl:when>
-      <xsl:otherwise>
-        <span class="ident">
-          <xsl:apply-templates/>
-        </span>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <xsl:template match="tei:gi">
-    <xsl:variable name="lookup" select="."/>
-    <xsl:choose>
-      <xsl:when test="parent::tei:ref or parent::tei:head or string-length(@scheme)&gt;0">
-        <span class="gi">
-          <xsl:text>&lt;</xsl:text>
-          <xsl:apply-templates/>
-          <xsl:text>&gt;</xsl:text>
-        </span>
-      </xsl:when>
-      <xsl:when test="key('ELEMENTS',$lookup)">
-        <xsl:for-each select="key('ELEMENTS',$lookup)[last()]">
-          <xsl:call-template name="linkTogether">
-            <xsl:with-param name="class">gi</xsl:with-param>
-            <xsl:with-param name="name">
-              <xsl:value-of select="@ident"/>
-            </xsl:with-param>
-            <xsl:with-param name="reftext">
-              <xsl:choose>
-                <xsl:when test="tei:content/rng:empty">
-                  <span class="emptySlash">
-                    <xsl:value-of select="(tei:altIdent|@ident)[last()]"/>
-                  </span>
-                </xsl:when>
-                <xsl:otherwise>
-                  <xsl:value-of select="(tei:altIdent|@ident)[last()]"/>
-                </xsl:otherwise>
-              </xsl:choose>
-            </xsl:with-param>
-          </xsl:call-template>
-        </xsl:for-each>
-      </xsl:when>
-      <xsl:otherwise>
-        <span class="gi">
-          <xsl:text>&lt;</xsl:text>
-          <xsl:apply-templates/>
-          <xsl:text>&gt;</xsl:text>
-        </span>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <xsl:template name="processSchemaFragment">
-    <xsl:param name="filename"/>
-    <div class="schemaFragment">
-      <xsl:if test="tei:elementSpec">
-        <h2>
-          <xsl:call-template name="i18n">
-            <xsl:with-param name="word">Elements defined</xsl:with-param>
-          </xsl:call-template>
-        </h2>
-        <xsl:apply-templates mode="weave" select="tei:elementSpec">
-          <xsl:sort select="tei:altIdent|@ident"/>
-        </xsl:apply-templates>
-      </xsl:if>
-      <xsl:if test="tei:classSpec">
-        <h2>
-          <xsl:call-template name="i18n">
-            <xsl:with-param name="word">Classes defined</xsl:with-param>
-          </xsl:call-template>
-        </h2>
-        <xsl:apply-templates mode="weave" select="tei:classSpec">
-          <xsl:sort select="tei:altIdent|@ident"/>
-        </xsl:apply-templates>
-      </xsl:if>
-      <xsl:if test="tei:macroSpec">
-        <h2>
-          <xsl:call-template name="i18n">
-            <xsl:with-param name="word">Macros defined</xsl:with-param>
-          </xsl:call-template>
-        </h2>
-        <xsl:apply-templates mode="weave" select="tei:macroSpec">
-          <xsl:sort select="tei:altIdent|@ident"/>
-        </xsl:apply-templates>
-      </xsl:if>
-      <xsl:apply-templates select="tei:specGrpRef"/>
-    </div>
-  </xsl:template>
-  <xsl:template name="listSpecs">
-    <xsl:for-each select="..//tei:schemaSpec">
-      <hr/>
-      <xsl:for-each select="tei:classSpec">
-        <xsl:sort select="tei:altIdent"/>
-        <xsl:sort select="@ident"/>
-        <xsl:element name="{$tocElement}">
-          <xsl:attribute name="class">toclist0</xsl:attribute>
-          <a class="toclist" href="#{@ident}">
-            <xsl:choose>
-              <xsl:when test="tei:altIdent">
-                <xsl:value-of select="tei:altIdent"/>
-              </xsl:when>
-              <xsl:otherwise>
-                <xsl:value-of select="@ident"/>
-              </xsl:otherwise>
-            </xsl:choose>
-          </a>
-        </xsl:element>
-      </xsl:for-each>
-      <hr/>
-      <xsl:for-each select="tei:elementSpec">
-        <xsl:sort select="tei:altIdent"/>
-        <xsl:sort select="@ident"/>
-        <xsl:element name="{$tocElement}">
-          <xsl:attribute name="class">toclist0</xsl:attribute>
-          <a class="toclist" href="#{@ident}">
-            <xsl:choose>
-              <xsl:when test="tei:altIdent">
-                <xsl:value-of select="tei:altIdent"/>
-              </xsl:when>
-              <xsl:otherwise>
-                <xsl:value-of select="@ident"/>
-              </xsl:otherwise>
-            </xsl:choose>
-          </a>
-        </xsl:element>
-      </xsl:for-each>
-      <hr/>
-      <xsl:for-each select="tei:macroSpec">
-        <xsl:sort select="tei:altIdent"/>
-        <xsl:sort select="@ident"/>
-        <xsl:element name="{$tocElement}">
-          <xsl:attribute name="class">toclist0</xsl:attribute>
-          <a class="toclist" href="#{@ident}">
-            <xsl:choose>
-              <xsl:when test="tei:altIdent">
-                <xsl:value-of select="tei:altIdent"/>
-              </xsl:when>
-              <xsl:otherwise>
-                <xsl:value-of select="@ident"/>
-              </xsl:otherwise>
-            </xsl:choose>
-          </a>
-        </xsl:element>
-      </xsl:for-each>
-    </xsl:for-each>
-  </xsl:template>
-  <xsl:template match="tei:elementSpec[@mode='delete']">
-    <dt>Element <xsl:value-of select="@ident"/>
-      </dt>
-    <dd>
-      <b>DELETED</b>
-    </dd>
-  </xsl:template>
-  <xsl:template name="verbatim-lineBreak">
-    <xsl:param name="id"/>
-    <xsl:text disable-output-escaping="yes">&lt;br/&gt;</xsl:text>
-  </xsl:template>
-  <xsl:template match="rng:ref/@name" mode="attributetext">
-    <xsl:variable name="me">
-      <xsl:choose>
-        <xsl:when test="contains(.,'.attributes')">
-          <xsl:value-of select="substring-before(.,'.attributes')"/>
-        </xsl:when>
-        <xsl:when test="contains(.,'.content')">
-          <xsl:value-of select="substring-before(.,'.content')"/>
-        </xsl:when>
-        <xsl:when test="contains(.,'.attribute.')">
-          <xsl:value-of select="substring-before(.,'.attribute.')"/>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:value-of select="."/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </xsl:variable>
-    <xsl:variable name="n" select="."/>
-    <xsl:choose>
-      <xsl:when test="contains(.,'.localattributes')">
-        <xsl:value-of select="$n"/>
-      </xsl:when>
-      <xsl:when test="contains(.,'.content')">
-        <xsl:value-of select="$n"/>
-      </xsl:when>
-      <xsl:when test="ancestor::teix:egXML">
-        <xsl:value-of select="$n"/>
-      </xsl:when>
-      <xsl:otherwise>
-        <xsl:for-each select="$top">
-          <xsl:call-template name="linkTogether">
-            <xsl:with-param name="name">
-              <xsl:value-of select="$me"/>
-            </xsl:with-param>
-            <xsl:with-param name="reftext">
-              <xsl:value-of select="$n"/>
-            </xsl:with-param>
-          </xsl:call-template>
-        </xsl:for-each>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <xsl:template match="rng:*">
-    <xsl:copy>
-      <xsl:copy-of select="@*"/>
-      <xsl:apply-templates select="rng:*|tei:*|text()|comment()"/>
-    </xsl:copy>
-  </xsl:template>
-  <xsl:template match="rng:zeroOrMore">
-    <xsl:choose>
-      <xsl:when test="count(rng:*)=1 and rng:zeroOrMore">
-        <xsl:apply-templates select="rng:*|tei:*|text()|comment()"/>
-      </xsl:when>
-      <xsl:otherwise>
-        <rng:zeroOrMore>
-          <xsl:copy-of select="@*"/>
-          <xsl:apply-templates select="rng:*|tei:*|text()|comment()"/>
-        </rng:zeroOrMore>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
-  <xsl:template match="tei:listRef" mode="weave"/>
-  <xsl:template match="tei:elementSpec[@mode='delete']" mode="weave"/>
-  <xsl:template match="a:documentation" mode="verbatim"/>
-  <xsl:template match="tei:ptr[@type='cit']">
-    <a class="citlink">
-      <xsl:for-each select="id(substring(@target,2))">
-        <xsl:attribute name="href">
-          <xsl:apply-templates select="." mode="generateLink"/>
+			<xsl:call-template name="makeAnchor">
+				<xsl:with-param name="name">
+					<xsl:value-of select="$id" />
+				</xsl:with-param>
+			</xsl:call-template>
+			<xsl:value-of select="$name" />
+			<xsl:if test="@ns">
+				[
+				<xsl:value-of select="@ns" />
+				]
+			</xsl:if>
+		</h3>
+	</xsl:template>
+	<xsl:template name="specHook">
+		<xsl:param name="name" />
+	</xsl:template>
+	<xsl:template match="tei:ident">
+		<xsl:choose>
+			<xsl:when test="@type='class' and key('CLASSES',.)">
+				<xsl:call-template name="linkTogether">
+					<xsl:with-param name="name">
+						<xsl:value-of select="." />
+					</xsl:with-param>
+					<xsl:with-param name="reftext">
+						<xsl:value-of select="." />
+					</xsl:with-param>
+				</xsl:call-template>
+			</xsl:when>
+			<xsl:when test="@type">
+				<span class="ident-{@type}">
+					<xsl:apply-templates />
+				</span>
+			</xsl:when>
+			<xsl:otherwise>
+				<span class="ident">
+					<xsl:apply-templates />
+				</span>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<xsl:template match="tei:gi">
+		<xsl:variable name="lookup" select="." />
+		<xsl:choose>
+			<xsl:when
+				test="parent::tei:ref or parent::tei:head or string-length(@scheme)&gt;0">
+				<span class="gi">
+					<xsl:text>&lt;</xsl:text>
+					<xsl:apply-templates />
+					<xsl:text>&gt;</xsl:text>
+				</span>
+			</xsl:when>
+			<xsl:when test="key('ELEMENTS',$lookup)">
+				<xsl:for-each select="key('ELEMENTS',$lookup)[last()]">
+					<xsl:call-template name="linkTogether">
+						<xsl:with-param name="class">
+							gi
+						</xsl:with-param>
+						<xsl:with-param name="name">
+							<xsl:value-of select="@ident" />
+						</xsl:with-param>
+						<xsl:with-param name="reftext">
+							<xsl:choose>
+								<xsl:when test="tei:content/rng:empty">
+									<span class="emptySlash">
+										<xsl:value-of
+											select="(tei:altIdent|@ident)[last()]" />
+									</span>
+								</xsl:when>
+								<xsl:otherwise>
+									<xsl:value-of
+										select="(tei:altIdent|@ident)[last()]" />
+								</xsl:otherwise>
+							</xsl:choose>
+						</xsl:with-param>
+					</xsl:call-template>
+				</xsl:for-each>
+			</xsl:when>
+			<xsl:otherwise>
+				<span class="gi">
+					<xsl:text>&lt;</xsl:text>
+					<xsl:apply-templates />
+					<xsl:text>&gt;</xsl:text>
+				</span>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<xsl:template name="processSchemaFragment">
+		<xsl:param name="filename" />
+		<div class="schemaFragment">
+			<xsl:if test="tei:elementSpec">
+				<h2>
+					<xsl:call-template name="i18n">
+						<xsl:with-param name="word">
+							Elements defined
+						</xsl:with-param>
+					</xsl:call-template>
+				</h2>
+				<xsl:apply-templates mode="weave"
+					select="tei:elementSpec">
+					<xsl:sort select="tei:altIdent|@ident" />
+				</xsl:apply-templates>
+			</xsl:if>
+			<xsl:if test="tei:classSpec">
+				<h2>
+					<xsl:call-template name="i18n">
+						<xsl:with-param name="word">
+							Classes defined
+						</xsl:with-param>
+					</xsl:call-template>
+				</h2>
+				<xsl:apply-templates mode="weave"
+					select="tei:classSpec">
+					<xsl:sort select="tei:altIdent|@ident" />
+				</xsl:apply-templates>
+			</xsl:if>
+			<xsl:if test="tei:macroSpec">
+				<h2>
+					<xsl:call-template name="i18n">
+						<xsl:with-param name="word">
+							Macros defined
+						</xsl:with-param>
+					</xsl:call-template>
+				</h2>
+				<xsl:apply-templates mode="weave"
+					select="tei:macroSpec">
+					<xsl:sort select="tei:altIdent|@ident" />
+				</xsl:apply-templates>
+			</xsl:if>
+			<xsl:apply-templates select="tei:specGrpRef" />
+		</div>
+	</xsl:template>
+	<xsl:template name="listSpecs">
+		<xsl:for-each select="..//tei:schemaSpec">
+			<hr />
+			<xsl:for-each select="tei:classSpec">
+				<xsl:sort select="tei:altIdent" />
+				<xsl:sort select="@ident" />
+				<xsl:element name="{$tocElement}">
+					<xsl:attribute name="class">toclist0</xsl:attribute>
+					<a class="toclist" href="#{@ident}">
+						<xsl:choose>
+							<xsl:when test="tei:altIdent">
+								<xsl:value-of select="tei:altIdent" />
+							</xsl:when>
+							<xsl:otherwise>
+								<xsl:value-of select="@ident" />
+							</xsl:otherwise>
+						</xsl:choose>
+					</a>
+				</xsl:element>
+			</xsl:for-each>
+			<hr />
+			<xsl:for-each select="tei:elementSpec">
+				<xsl:sort select="tei:altIdent" />
+				<xsl:sort select="@ident" />
+				<xsl:element name="{$tocElement}">
+					<xsl:attribute name="class">toclist0</xsl:attribute>
+					<a class="toclist" href="#{@ident}">
+						<xsl:choose>
+							<xsl:when test="tei:altIdent">
+								<xsl:value-of select="tei:altIdent" />
+							</xsl:when>
+							<xsl:otherwise>
+								<xsl:value-of select="@ident" />
+							</xsl:otherwise>
+						</xsl:choose>
+					</a>
+				</xsl:element>
+			</xsl:for-each>
+			<hr />
+			<xsl:for-each select="tei:macroSpec">
+				<xsl:sort select="tei:altIdent" />
+				<xsl:sort select="@ident" />
+				<xsl:element name="{$tocElement}">
+					<xsl:attribute name="class">toclist0</xsl:attribute>
+					<a class="toclist" href="#{@ident}">
+						<xsl:choose>
+							<xsl:when test="tei:altIdent">
+								<xsl:value-of select="tei:altIdent" />
+							</xsl:when>
+							<xsl:otherwise>
+								<xsl:value-of select="@ident" />
+							</xsl:otherwise>
+						</xsl:choose>
+					</a>
+				</xsl:element>
+			</xsl:for-each>
+		</xsl:for-each>
+	</xsl:template>
+	<xsl:template match="tei:elementSpec[@mode='delete']">
+		<dt>
+			Element
+			<xsl:value-of select="@ident" />
+		</dt>
+		<dd>
+			<b>DELETED</b>
+		</dd>
+	</xsl:template>
+	<xsl:template name="verbatim-lineBreak">
+		<xsl:param name="id" />
+		<xsl:text disable-output-escaping="yes">&lt;br/&gt;</xsl:text>
+	</xsl:template>
+	<xsl:template match="rng:ref/@name" mode="attributetext">
+		<xsl:variable name="me">
+			<xsl:choose>
+				<xsl:when test="contains(.,'.attributes')">
+					<xsl:value-of
+						select="substring-before(.,'.attributes')" />
+				</xsl:when>
+				<xsl:when test="contains(.,'.content')">
+					<xsl:value-of select="substring-before(.,'.content')" />
+				</xsl:when>
+				<xsl:when test="contains(.,'.attribute.')">
+					<xsl:value-of
+						select="substring-before(.,'.attribute.')" />
+				</xsl:when>
+				<xsl:otherwise>
+					<xsl:value-of select="." />
+				</xsl:otherwise>
+			</xsl:choose>
+		</xsl:variable>
+		<xsl:variable name="n" select="." />
+		<xsl:choose>
+			<xsl:when test="contains(.,'.localattributes')">
+				<xsl:value-of select="$n" />
+			</xsl:when>
+			<xsl:when test="contains(.,'.content')">
+				<xsl:value-of select="$n" />
+			</xsl:when>
+			<xsl:when test="ancestor::teix:egXML">
+				<xsl:value-of select="$n" />
+			</xsl:when>
+			<xsl:otherwise>
+				<xsl:for-each select="$top">
+					<xsl:call-template name="linkTogether">
+						<xsl:with-param name="name">
+							<xsl:value-of select="$me" />
+						</xsl:with-param>
+						<xsl:with-param name="reftext">
+							<xsl:value-of select="$n" />
+						</xsl:with-param>
+					</xsl:call-template>
+				</xsl:for-each>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<xsl:template match="rng:*">
+		<xsl:copy>
+			<xsl:copy-of select="@*" />
+			<xsl:apply-templates
+				select="rng:*|tei:*|text()|comment()" />
+		</xsl:copy>
+	</xsl:template>
+	<xsl:template match="rng:zeroOrMore">
+		<xsl:choose>
+			<xsl:when test="count(rng:*)=1 and rng:zeroOrMore">
+				<xsl:apply-templates
+					select="rng:*|tei:*|text()|comment()" />
+			</xsl:when>
+			<xsl:otherwise>
+				<rng:zeroOrMore>
+					<xsl:copy-of select="@*" />
+					<xsl:apply-templates
+						select="rng:*|tei:*|text()|comment()" />
+				</rng:zeroOrMore>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	<xsl:template match="tei:listRef" mode="weave" />
+	<xsl:template match="tei:elementSpec[@mode='delete']"
+		mode="weave" />
+	<xsl:template match="a:documentation" mode="verbatim" />
+	<xsl:template match="tei:ptr[@type='cit']">
+		<a class="citlink">
+			<xsl:for-each select="id(substring(@target,2))">
+				<xsl:attribute name="href">
+          <xsl:apply-templates select="."
+					mode="generateLink" />
         </xsl:attribute>
-        <xsl:apply-templates select="." mode="xref"/>
-      </xsl:for-each>
-    </a>
-  </xsl:template>
-  <xsl:template match="tei:divGen[@type='macrocat']" priority="100">
-    <h3>Alphabetical list</h3>
-    <xsl:for-each select="key('MACRODOCS',1)">
-      <xsl:sort select="@module"/>
-      <xsl:if test="generate-id(.)=generate-id(key('MACRO-MODULE',@module)[1])">
-        <div id="macro-{@module}">
-          <h3>
-            <xsl:for-each select="key('MODULES',@module)">
-              <xsl:text>[</xsl:text>
-              <xsl:value-of select="@ident"/>
-              <xsl:text>] </xsl:text>
-              <xsl:call-template name="makeDescription"/>
-            </xsl:for-each>
-          </h3>
-          <xsl:for-each select="key('MACRO-MODULE',@module)">
-            <xsl:sort select="@ident"/>
-            <xsl:call-template name="refDocLink"/>
-          </xsl:for-each>
-        </div>
-      </xsl:if>
-    </xsl:for-each>
-    <xsl:apply-templates mode="weave" select="key('MACRODOCS',1)">
-      <xsl:sort select="@ident"/>
-    </xsl:apply-templates>
-  </xsl:template>
-  <xsl:template match="tei:divGen[@type='elementcat']"  priority="100">
-    <div class="atozwrapper">
-      <xsl:call-template name="atozHeader">
-        <xsl:with-param name="Key">ELEMENT-ALPHA</xsl:with-param>
-      </xsl:call-template>
-      <xsl:for-each select="key('ELEMENTDOCS',1)">
-        <xsl:sort select="lower-case(@ident)"/>
-        <xsl:variable name="letter">
-          <xsl:value-of select="substring(@ident,1,1)"/>
-        </xsl:variable>
-        <xsl:if test="generate-id(.)=generate-id(key('ELEMENT-ALPHA',$letter)[1])">
-          <div id="element-{$letter}" class="atoz">
-            <span class="listhead">
-              <xsl:value-of select="$letter"/>
-            </span>
-            <ul class="atoz">
-              <xsl:for-each select="key('ELEMENT-ALPHA',$letter)">
-                <xsl:sort select="@ident"/>
-                <li>
-		  <xsl:call-template name="refDocLink"/>
-                </li>
-              </xsl:for-each>
-            </ul>
-          </div>
-        </xsl:if>
-      </xsl:for-each>
-    </div>
-    <div id="byMod">
-      <xsl:for-each select="key('ELEMENTDOCS',1)">
-        <xsl:sort select="@module"/>
-        <xsl:if test="generate-id(.)=generate-id(key('ELEMENT-MODULE',@module)[1])">
-          <div>
-            <h3>
-              <xsl:for-each select="key('MODULES',@module)">
-                <xsl:text>[</xsl:text>
-                <xsl:value-of select="@ident"/>
-                <xsl:text>] </xsl:text>
-                <xsl:call-template name="makeDescription"/>
-              </xsl:for-each>
-            </h3>
-            <xsl:for-each select="key('ELEMENT-MODULE',@module)">
-              <xsl:sort
-		  select="@ident"/>
-	      <xsl:call-template name="refDocLink"/>
-	    </xsl:for-each>
-          </div>
-        </xsl:if>
-      </xsl:for-each>
-    </div>
-    <xsl:for-each select="key('ELEMENTDOCS',1)">
-      <xsl:apply-templates mode="weave" select="."/>
-    </xsl:for-each>
-  </xsl:template>
+				<xsl:apply-templates select="." mode="xref" />
+			</xsl:for-each>
+		</a>
+	</xsl:template>
+	<xsl:template match="tei:divGen[@type='macrocat']"
+		priority="100">
+		<h3>Alphabetical list</h3>
+		<xsl:for-each select="key('MACRODOCS',1)">
+			<xsl:sort select="@module" />
+			<xsl:if
+				test="generate-id(.)=generate-id(key('MACRO-MODULE',@module)[1])">
+				<div id="macro-{@module}">
+					<h3>
+						<xsl:for-each select="key('MODULES',@module)">
+							<xsl:text>[</xsl:text>
+							<xsl:value-of select="@ident" />
+							<xsl:text>] </xsl:text>
+							<xsl:call-template name="makeDescription" />
+						</xsl:for-each>
+					</h3>
+					<xsl:for-each select="key('MACRO-MODULE',@module)">
+						<xsl:sort select="@ident" />
+						<xsl:call-template name="refDocLink" />
+					</xsl:for-each>
+				</div>
+			</xsl:if>
+		</xsl:for-each>
+		<xsl:apply-templates mode="weave"
+			select="key('MACRODOCS',1)">
+			<xsl:sort select="@ident" />
+		</xsl:apply-templates>
+	</xsl:template>
+	<xsl:template match="tei:divGen[@type='elementcat']"
+		priority="100">
+		<div class="atozwrapper">
+			<xsl:call-template name="atozHeader">
+				<xsl:with-param name="Key">
+					ELEMENT-ALPHA
+				</xsl:with-param>
+			</xsl:call-template>
+			<xsl:for-each select="key('ELEMENTDOCS',1)">
+				<xsl:sort select="lower-case(@ident)" />
+				<xsl:variable name="letter">
+					<xsl:value-of select="substring(@ident,1,1)" />
+				</xsl:variable>
+				<xsl:if
+					test="generate-id(.)=generate-id(key('ELEMENT-ALPHA',$letter)[1])">
+					<div id="element-{$letter}" class="atoz">
+						<span class="listhead">
+							<xsl:value-of select="$letter" />
+						</span>
+						<ul class="atoz">
+							<xsl:for-each select="key('ELEMENT-ALPHA',$letter)">
+								<xsl:sort select="@ident" />
+								<li>
+									<xsl:call-template name="refDocLink" />
+								</li>
+							</xsl:for-each>
+						</ul>
+					</div>
+				</xsl:if>
+			</xsl:for-each>
+		</div>
+		<div id="byMod">
+			<xsl:for-each select="key('ELEMENTDOCS',1)">
+				<xsl:sort select="@module" />
+				<xsl:if
+					test="generate-id(.)=generate-id(key('ELEMENT-MODULE',@module)[1])">
+					<div>
+						<h3>
+							<xsl:for-each select="key('MODULES',@module)">
+								<xsl:text>[</xsl:text>
+								<xsl:value-of select="@ident" />
+								<xsl:text>] </xsl:text>
+								<xsl:call-template name="makeDescription" />
+							</xsl:for-each>
+						</h3>
+						<xsl:for-each select="key('ELEMENT-MODULE',@module)">
+							<xsl:sort select="@ident" />
+							<xsl:call-template name="refDocLink" />
+						</xsl:for-each>
+					</div>
+				</xsl:if>
+			</xsl:for-each>
+		</div>
+		<xsl:for-each select="key('ELEMENTDOCS',1)">
+			<xsl:apply-templates mode="weave" select="." />
+		</xsl:for-each>
+	</xsl:template>
 
 
-  <xsl:template name="refDocLink">
-    <span
-	class="refDocLink">
-      <a>
-	<xsl:attribute name="href">
+	<xsl:template name="refDocLink">
+		<span class="refDocLink">
+			<a>
+				<xsl:attribute name="href">
 	  <xsl:choose>
 	    <xsl:when test="number($splitLevel)=-1 or $STDOUT='true'">
 	      <xsl:text>#</xsl:text>
-	      <xsl:value-of select="@ident"/>
+	      <xsl:value-of select="@ident" />
 	    </xsl:when>
 	    <xsl:otherwise>
 	      <xsl:text>ref-</xsl:text>
-	      <xsl:value-of
-		  select="@ident"/>
-	      <xsl:value-of select="$outputSuffix"/>
+	      <xsl:value-of select="@ident" />
+	      <xsl:value-of select="$outputSuffix" />
 	    </xsl:otherwise>
 	  </xsl:choose>
 	</xsl:attribute>
-	<xsl:value-of select="@ident"/>
-      </a>
-      <xsl:text> </xsl:text>
-    </span>
-  </xsl:template>
+				<xsl:value-of select="@ident" />
+			</a>
+			<xsl:text> </xsl:text>
+		</span>
+	</xsl:template>
 
-  <xsl:template match="tei:divGen[@type='modelclasscat']"  priority="100">
-    <div class="atozwrapper">
-      <xsl:call-template name="atozHeader">
-        <xsl:with-param name="Key">MODEL-CLASS-ALPHA</xsl:with-param>
-      </xsl:call-template>
-      <xsl:for-each select="key('MODELCLASSDOCS',1)">
-        <xsl:sort select="lower-case(substring-after(@ident,'model.'))"/>
-        <xsl:variable name="letter">
-          <xsl:value-of select="substring(@ident,7,1)"/>
-        </xsl:variable>
-        <xsl:if test="generate-id(.)=generate-id(key('MODEL-CLASS-ALPHA',$letter)[1])">
-          <div id="element-{$letter}" class="atoz">
-            <span class="listhead">
-              <xsl:value-of select="$letter"/>
-            </span>
-            <ul class="atoz">
-              <xsl:for-each select="key('MODEL-CLASS-ALPHA',$letter)">
-                <xsl:sort select="lower-case(substring-after(@ident,'model.'))"/>
-                <li>
-		  <xsl:call-template name="refDocLink"/>
-                </li>
-              </xsl:for-each>
-            </ul>
-          </div>
-        </xsl:if>
-      </xsl:for-each>
-    </div>
-    <div id="byMod">
-      <xsl:for-each select="key('MODELCLASSDOCS',1)">
-        <xsl:sort select="@module"/>
-        <xsl:if test="generate-id(.)=generate-id(key('MODEL-CLASS-MODULE',@module)[1])">
-          <div>
-            <h3>
-              <xsl:for-each select="key('MODULES',@module)">
-                <xsl:text>[</xsl:text>
-                <xsl:value-of select="@ident"/>
-                <xsl:text>] </xsl:text>
-                <xsl:call-template name="makeDescription"/>
-              </xsl:for-each>
-            </h3>
-            <xsl:for-each select="key('MODEL-CLASS-MODULE',@module)">
-              <xsl:sort
-		  select="@ident"/>
-	      <xsl:call-template name="refDocLink"/>
-            </xsl:for-each>
-          </div>
-        </xsl:if>
-      </xsl:for-each>
-    </div>
-    <xsl:for-each select="key('MODELCLASSDOCS',1)">
-      <xsl:apply-templates select="." mode="weave"/>
-    </xsl:for-each>
-  </xsl:template>
-  <xsl:template match="tei:divGen[@type='attclasscat']"  priority="100">
-    <div class="atozwrapper">
-      <xsl:call-template name="atozHeader">
-        <xsl:with-param name="Key">ATT-CLASS-ALPHA</xsl:with-param>
-      </xsl:call-template>
-      <xsl:for-each select="key('ATTCLASSDOCS',1)">
-        <xsl:sort select="lower-case(substring-after(@ident,'att.'))"/>
-        <xsl:variable name="letter">
-          <xsl:value-of select="substring(@ident,5,1)"/>
-        </xsl:variable>
-        <xsl:if test="generate-id(.)=generate-id(key('ATT-CLASS-ALPHA',$letter)[1])">
-          <div id="element-{$letter}" class="atoz">
-            <span class="listhead">
-              <xsl:value-of select="$letter"/>
-            </span>
-            <ul class="atoz">
-              <xsl:for-each select="key('ATT-CLASS-ALPHA',$letter)">
-                <xsl:sort select="lower-case(substring-after(@ident,'att.'))"/>
-                <li>
-		  <xsl:call-template name="refDocLink"/>
-		</li>
-              </xsl:for-each>
-            </ul>
-          </div>
-        </xsl:if>
-      </xsl:for-each>
-    </div>
-    <div id="byMod">
-      <xsl:for-each select="key('ATTCLASSDOCS',1)">
-        <xsl:sort select="@module"/>
-        <xsl:if test="generate-id(.)=generate-id(key('ATT-CLASS-MODULE',@module)[1])">
-          <div>
-            <h3>
-              <xsl:for-each select="key('MODULES',@module)">
-                <xsl:text>[</xsl:text>
-                <xsl:value-of select="@ident"/>
-                <xsl:text>] </xsl:text>
-                <xsl:call-template name="makeDescription"/>
-              </xsl:for-each>
-            </h3>
-            <xsl:for-each
-		select="key('ATT-CLASS-MODULE',@module)">
-	      <xsl:call-template name="refDocLink"/>
-            </xsl:for-each>
-          </div>
-        </xsl:if>
-      </xsl:for-each>
-    </div>
-    <xsl:apply-templates mode="weave" select="key('ATTCLASSDOCS',1)">
-      <xsl:sort select="@ident"/>
-    </xsl:apply-templates>
-  </xsl:template>
-  <xsl:template name="javascriptHook">
-    <xsl:call-template name="jsForOdds"/>
-  </xsl:template>
-  <xsl:template name="jsForOdds">
-    <script type="text/javascript">
-      <xsl:comment>
-        <xsl:text disable-output-escaping="yes">
+	<xsl:template match="tei:divGen[@type='modelclasscat']"
+		priority="100">
+		<div class="atozwrapper">
+			<xsl:call-template name="atozHeader">
+				<xsl:with-param name="Key">
+					MODEL-CLASS-ALPHA
+				</xsl:with-param>
+			</xsl:call-template>
+			<xsl:for-each select="key('MODELCLASSDOCS',1)">
+				<xsl:sort
+					select="lower-case(substring-after(@ident,'model.'))" />
+				<xsl:variable name="letter">
+					<xsl:value-of select="substring(@ident,7,1)" />
+				</xsl:variable>
+				<xsl:if
+					test="generate-id(.)=generate-id(key('MODEL-CLASS-ALPHA',$letter)[1])">
+					<div id="element-{$letter}" class="atoz">
+						<span class="listhead">
+							<xsl:value-of select="$letter" />
+						</span>
+						<ul class="atoz">
+							<xsl:for-each
+								select="key('MODEL-CLASS-ALPHA',$letter)">
+								<xsl:sort
+									select="lower-case(substring-after(@ident,'model.'))" />
+								<li>
+									<xsl:call-template name="refDocLink" />
+								</li>
+							</xsl:for-each>
+						</ul>
+					</div>
+				</xsl:if>
+			</xsl:for-each>
+		</div>
+		<div id="byMod">
+			<xsl:for-each select="key('MODELCLASSDOCS',1)">
+				<xsl:sort select="@module" />
+				<xsl:if
+					test="generate-id(.)=generate-id(key('MODEL-CLASS-MODULE',@module)[1])">
+					<div>
+						<h3>
+							<xsl:for-each select="key('MODULES',@module)">
+								<xsl:text>[</xsl:text>
+								<xsl:value-of select="@ident" />
+								<xsl:text>] </xsl:text>
+								<xsl:call-template name="makeDescription" />
+							</xsl:for-each>
+						</h3>
+						<xsl:for-each
+							select="key('MODEL-CLASS-MODULE',@module)">
+							<xsl:sort select="@ident" />
+							<xsl:call-template name="refDocLink" />
+						</xsl:for-each>
+					</div>
+				</xsl:if>
+			</xsl:for-each>
+		</div>
+		<xsl:for-each select="key('MODELCLASSDOCS',1)">
+			<xsl:apply-templates select="." mode="weave" />
+		</xsl:for-each>
+	</xsl:template>
+	<xsl:template match="tei:divGen[@type='attclasscat']"
+		priority="100">
+		<div class="atozwrapper">
+			<xsl:call-template name="atozHeader">
+				<xsl:with-param name="Key">
+					ATT-CLASS-ALPHA
+				</xsl:with-param>
+			</xsl:call-template>
+			<xsl:for-each select="key('ATTCLASSDOCS',1)">
+				<xsl:sort
+					select="lower-case(substring-after(@ident,'att.'))" />
+				<xsl:variable name="letter">
+					<xsl:value-of select="substring(@ident,5,1)" />
+				</xsl:variable>
+				<xsl:if
+					test="generate-id(.)=generate-id(key('ATT-CLASS-ALPHA',$letter)[1])">
+					<div id="element-{$letter}" class="atoz">
+						<span class="listhead">
+							<xsl:value-of select="$letter" />
+						</span>
+						<ul class="atoz">
+							<xsl:for-each
+								select="key('ATT-CLASS-ALPHA',$letter)">
+								<xsl:sort
+									select="lower-case(substring-after(@ident,'att.'))" />
+								<li>
+									<xsl:call-template name="refDocLink" />
+								</li>
+							</xsl:for-each>
+						</ul>
+					</div>
+				</xsl:if>
+			</xsl:for-each>
+		</div>
+		<div id="byMod">
+			<xsl:for-each select="key('ATTCLASSDOCS',1)">
+				<xsl:sort select="@module" />
+				<xsl:if
+					test="generate-id(.)=generate-id(key('ATT-CLASS-MODULE',@module)[1])">
+					<div>
+						<h3>
+							<xsl:for-each select="key('MODULES',@module)">
+								<xsl:text>[</xsl:text>
+								<xsl:value-of select="@ident" />
+								<xsl:text>] </xsl:text>
+								<xsl:call-template name="makeDescription" />
+							</xsl:for-each>
+						</h3>
+						<xsl:for-each
+							select="key('ATT-CLASS-MODULE',@module)">
+							<xsl:call-template name="refDocLink" />
+						</xsl:for-each>
+					</div>
+				</xsl:if>
+			</xsl:for-each>
+		</div>
+		<xsl:apply-templates mode="weave"
+			select="key('ATTCLASSDOCS',1)">
+			<xsl:sort select="@ident" />
+		</xsl:apply-templates>
+	</xsl:template>
+	<xsl:template name="javascriptHook">
+		<xsl:call-template name="jsForOdds" />
+	</xsl:template>
+	<xsl:template name="jsForOdds">
+		<script type="text/javascript">
+			<xsl:comment>
+				<xsl:text disable-output-escaping="yes">
 var displayXML=0;
 states=new Array()
 states[0]="element-a"
